/** @file gui.h

	Skelton for retropc emulator
	SDL edition

	@author Sasaji
	@date   2015.04.01

	@brief [ gui ]
*/

#ifndef _GUI_H_
#define _GUI_H_

#if defined(GUI_TYPE_AGAR)

#include "agar/ag_gui.h"
#define GUI_IMPL GUI_AGAR::AG_GUI

#elif defined(GUI_TYPE_WINDOWS)

#define NOT_USE_GETTEXT_ACP 1
#include "windows/win_gui.h"
#define GUI_IMPL GUI_WIN::GUI

#elif defined(GUI_TYPE_COCOA)

#include "cocoa/cocoa_gui.h"
#define GUI_IMPL COCOA_GUI

#elif defined(GUI_TYPE_GTK_X11)

#include "gtk_x11/gtk_x11_gui.h"
#define GUI_IMPL GUI_GTK_X11::GUI

#else

#include "gui_base.h"
#define GUI_IMPL GUI_BASE

#endif

class GUI : public GUI_IMPL
{
public:
	GUI(int argc, char **argv, EMU *new_emu) : GUI_IMPL(argc, argv, new_emu) {}
};

#endif /* _GUI_H_ */
