/** @file keycode.h

	Skelton for retropc emulator


	@author Sasaji
	@date   2015.04.30

	@brief [ keycode ]
*/

#ifndef _KEYCODE_H_
#define _KEYCODE_H_

#ifndef USE_SDL2
/* SDL1 */

#define KEYCODE_UNKNOWN			SDLK_UNKNOWN

#define KEYCODE_BACKSPACE		SDLK_BACKSPACE
#define KEYCODE_TAB				SDLK_TAB
#define KEYCODE_CLEAR			SDLK_CLEAR
#define KEYCODE_RETURN			SDLK_RETURN
#define KEYCODE_PAUSE			SDLK_PAUSE
#define KEYCODE_ESCAPE			SDLK_ESCAPE
#define KEYCODE_SPACE			SDLK_SPACE
#define KEYCODE_EXCLAIM			SDLK_EXCLAIM
#define KEYCODE_QUOTEDBL		SDLK_QUOTEDBL
#define KEYCODE_HASH			SDLK_HASH
#define KEYCODE_DOLLAR			SDLK_DOLLAR
#define KEYCODE_AMPERSAND		SDLK_AMPERSAND
#define KEYCODE_QUOTE			SDLK_QUOTE
#define KEYCODE_LEFTPAREN		SDLK_LEFTPAREN
#define KEYCODE_RIGHTPAREN		SDLK_RIGHTPAREN
#define KEYCODE_ASTERISK		SDLK_ASTERISK
#define KEYCODE_PLUS			SDLK_PLUS
#define KEYCODE_COMMA			SDLK_COMMA
#define KEYCODE_MINUS			SDLK_MINUS
#define KEYCODE_PERIOD			SDLK_PERIOD
#define KEYCODE_SLASH			SDLK_SLASH
#define KEYCODE_0				SDLK_0
#define KEYCODE_1				SDLK_1
#define KEYCODE_2				SDLK_2
#define KEYCODE_3				SDLK_3
#define KEYCODE_4				SDLK_4
#define KEYCODE_5				SDLK_5
#define KEYCODE_6				SDLK_6
#define KEYCODE_7				SDLK_7
#define KEYCODE_8				SDLK_8
#define KEYCODE_9				SDLK_9
#define KEYCODE_COLON			SDLK_COLON
#define KEYCODE_SEMICOLON		SDLK_SEMICOLON
#define KEYCODE_LESS			SDLK_LESS
#define KEYCODE_EQUALS			SDLK_EQUALS
#define KEYCODE_GREATER			SDLK_GREATER
#define KEYCODE_QUESTION		SDLK_QUESTION
#define KEYCODE_AT				SDLK_AT

#define KEYCODE_LEFTBRACKET		SDLK_LEFTBRACKET
#define KEYCODE_BACKSLASH		SDLK_BACKSLASH
#define KEYCODE_RIGHTBRACKET	SDLK_RIGHTBRACKET
#define KEYCODE_CARET			SDLK_CARET
#define KEYCODE_UNDERSCORE		SDLK_UNDERSCORE
#define KEYCODE_GRAVE			SDLK_BACKQUOTE
#define KEYCODE_A				SDLK_a
#define KEYCODE_B				SDLK_b
#define KEYCODE_C				SDLK_c
#define KEYCODE_D				SDLK_d
#define KEYCODE_E				SDLK_e
#define KEYCODE_F				SDLK_f
#define KEYCODE_G				SDLK_g
#define KEYCODE_H				SDLK_h
#define KEYCODE_I				SDLK_i
#define KEYCODE_J				SDLK_j
#define KEYCODE_K				SDLK_k
#define KEYCODE_L				SDLK_l
#define KEYCODE_M				SDLK_m
#define KEYCODE_N				SDLK_n
#define KEYCODE_O				SDLK_o
#define KEYCODE_P				SDLK_p
#define KEYCODE_Q				SDLK_q
#define KEYCODE_R				SDLK_r
#define KEYCODE_S				SDLK_s
#define KEYCODE_T				SDLK_t
#define KEYCODE_U				SDLK_u
#define KEYCODE_V				SDLK_v
#define KEYCODE_W				SDLK_w
#define KEYCODE_X				SDLK_x
#define KEYCODE_Y				SDLK_y
#define KEYCODE_Z				SDLK_z
#define KEYCODE_DELETE			SDLK_DELETE

#define KEYCODE_WORLD_0			SDLK_WORLD_0
#define KEYCODE_WORLD_1			SDLK_WORLD_1
#define KEYCODE_WORLD_2			SDLK_WORLD_2
#define KEYCODE_WORLD_3			SDLK_WORLD_3
#define KEYCODE_WORLD_4			SDLK_WORLD_4
#define KEYCODE_WORLD_5			SDLK_WORLD_5
#define KEYCODE_WORLD_6			SDLK_WORLD_6
#define KEYCODE_WORLD_7			SDLK_WORLD_7
#define KEYCODE_WORLD_8			SDLK_WORLD_8
#define KEYCODE_WORLD_9			SDLK_WORLD_9

#define KEYCODE_KP_0			SDLK_KP0
#define KEYCODE_KP_1			SDLK_KP1
#define KEYCODE_KP_2			SDLK_KP2
#define KEYCODE_KP_3			SDLK_KP3
#define KEYCODE_KP_4			SDLK_KP4
#define KEYCODE_KP_5			SDLK_KP5
#define KEYCODE_KP_6			SDLK_KP6
#define KEYCODE_KP_7			SDLK_KP7
#define KEYCODE_KP_8			SDLK_KP8
#define KEYCODE_KP_9			SDLK_KP9
#define KEYCODE_KP_PERIOD		SDLK_KP_PERIOD
#define KEYCODE_KP_DIVIDE		SDLK_KP_DIVIDE
#define KEYCODE_KP_MULTIPLY		SDLK_KP_MULTIPLY
#define KEYCODE_KP_MINUS		SDLK_KP_MINUS
#define KEYCODE_KP_PLUS			SDLK_KP_PLUS
#define KEYCODE_KP_ENTER		SDLK_KP_ENTER
#define KEYCODE_KP_EQUALS		SDLK_KP_EQUALS

#define KEYCODE_UP				SDLK_UP
#define KEYCODE_DOWN			SDLK_DOWN
#define KEYCODE_RIGHT			SDLK_RIGHT
#define KEYCODE_LEFT			SDLK_LEFT
#define KEYCODE_INSERT			SDLK_INSERT
#define KEYCODE_HOME			SDLK_HOME
#define KEYCODE_END				SDLK_END
#define KEYCODE_PAGEUP			SDLK_PAGEUP
#define KEYCODE_PAGEDOWN		SDLK_PAGEDOWN

#define KEYCODE_F1				SDLK_F1
#define KEYCODE_F2				SDLK_F2
#define KEYCODE_F3				SDLK_F3
#define KEYCODE_F4				SDLK_F4
#define KEYCODE_F5				SDLK_F5
#define KEYCODE_F6				SDLK_F6
#define KEYCODE_F7				SDLK_F7
#define KEYCODE_F8				SDLK_F8
#define KEYCODE_F9				SDLK_F9
#define KEYCODE_F10				SDLK_F10
#define KEYCODE_F11				SDLK_F11
#define KEYCODE_F12				SDLK_F12
#define KEYCODE_F13				SDLK_F13
#define KEYCODE_F14				SDLK_F14
#define KEYCODE_F15				SDLK_F15
// for mac keyboard
#define KEYCODE_F16				SDLK_WORLD_6
#define KEYCODE_F17				SDLK_WORLD_7
#define KEYCODE_F18				SDLK_WORLD_8
#define KEYCODE_F19				SDLK_WORLD_9

#define KEYCODE_NUMLOCKCLEAR	SDLK_NUMLOCK
#define KEYCODE_CAPSLOCK		SDLK_CAPSLOCK
#define KEYCODE_SCROLLLOCK		SDLK_SCROLLOCK
#define KEYCODE_RSHIFT			SDLK_RSHIFT
#define KEYCODE_LSHIFT			SDLK_LSHIFT
#define KEYCODE_RCTRL			SDLK_RCTRL
#define KEYCODE_LCTRL			SDLK_LCTRL
#define KEYCODE_RALT			SDLK_RALT
#define KEYCODE_LALT			SDLK_LALT
#define KEYCODE_RGUI			SDLK_RMETA
#define KEYCODE_LGUI			SDLK_LMETA
#define KEYCODE_LSUPER			SDLK_LSUPER
#define KEYCODE_RSUPER			SDLK_RSUPER
#define KEYCODE_MODE			SDLK_MODE
#define KEYCODE_COMPOSE			SDLK_COMPOSE

#define KEYCODE_HELP			SDLK_HELP
#define KEYCODE_PRINT			SDLK_PRINT
#define KEYCODE_SYSREQ			SDLK_SYSREQ
#define KEYCODE_BREAK			SDLK_BREAK
#define KEYCODE_MENU			SDLK_MENU
#define KEYCODE_POWER			SDLK_POWER
#define KEYCODE_EURO			SDLK_EURO
#define KEYCODE_UNDO			SDLK_UNDO

/* henkan */
#define KEYCODE_HENKAN			SDLK_WORLD_0
/* muhenkan */
#define KEYCODE_MUHENKAN		SDLK_WORLD_1
/* katakana / hiragana */
#define KEYCODE_KATAHIRA		SDLK_WORLD_2
/* eisu(mac) */
#define KEYCODE_EISU			SDLK_WORLD_3
/* kana(mac) */
#define KEYCODE_KANA			SDLK_WORLD_4
/* fn */
#define KEYCODE_FUNCTION		SDLK_WORLD_5

#else
/* SDL2 */

#define KEYCODE_UNKNOWN			SDL_SCANCODE_UNKNOWN

#define KEYCODE_A				SDL_SCANCODE_A
#define KEYCODE_B				SDL_SCANCODE_B
#define KEYCODE_C				SDL_SCANCODE_C
#define KEYCODE_D				SDL_SCANCODE_D
#define KEYCODE_E				SDL_SCANCODE_E
#define KEYCODE_F				SDL_SCANCODE_F
#define KEYCODE_G				SDL_SCANCODE_G
#define KEYCODE_H				SDL_SCANCODE_H
#define KEYCODE_I				SDL_SCANCODE_I
#define KEYCODE_J				SDL_SCANCODE_J
#define KEYCODE_K				SDL_SCANCODE_K
#define KEYCODE_L				SDL_SCANCODE_L
#define KEYCODE_M				SDL_SCANCODE_M
#define KEYCODE_N				SDL_SCANCODE_N
#define KEYCODE_O				SDL_SCANCODE_O
#define KEYCODE_P				SDL_SCANCODE_P
#define KEYCODE_Q				SDL_SCANCODE_Q
#define KEYCODE_R				SDL_SCANCODE_R
#define KEYCODE_S				SDL_SCANCODE_S
#define KEYCODE_T				SDL_SCANCODE_T
#define KEYCODE_U				SDL_SCANCODE_U
#define KEYCODE_V				SDL_SCANCODE_V
#define KEYCODE_W				SDL_SCANCODE_W
#define KEYCODE_X				SDL_SCANCODE_X
#define KEYCODE_Y				SDL_SCANCODE_Y
#define KEYCODE_Z				SDL_SCANCODE_Z

#define KEYCODE_1				SDL_SCANCODE_1
#define KEYCODE_2				SDL_SCANCODE_2
#define KEYCODE_3				SDL_SCANCODE_3
#define KEYCODE_4				SDL_SCANCODE_4
#define KEYCODE_5				SDL_SCANCODE_5
#define KEYCODE_6				SDL_SCANCODE_6
#define KEYCODE_7				SDL_SCANCODE_7
#define KEYCODE_8				SDL_SCANCODE_8
#define KEYCODE_9				SDL_SCANCODE_9
#define KEYCODE_0				SDL_SCANCODE_0

#define KEYCODE_RETURN			SDL_SCANCODE_RETURN
#define KEYCODE_ESCAPE			SDL_SCANCODE_ESCAPE
#define KEYCODE_BACKSPACE		SDL_SCANCODE_BACKSPACE
#define KEYCODE_TAB				SDL_SCANCODE_TAB
#define KEYCODE_SPACE			SDL_SCANCODE_SPACE

#define KEYCODE_MINUS			SDL_SCANCODE_MINUS
#define KEYCODE_EQUALS			SDL_SCANCODE_EQUALS
#define KEYCODE_LEFTBRACKET		SDL_SCANCODE_LEFTBRACKET
#define KEYCODE_RIGHTBRACKET	SDL_SCANCODE_RIGHTBRACKET
#define KEYCODE_BACKSLASH		SDL_SCANCODE_BACKSLASH

#define KEYCODE_NONUSHASH		SDL_SCANCODE_NONUSHASH

#define KEYCODE_SEMICOLON		SDL_SCANCODE_SEMICOLON
#define KEYCODE_APOSTROPHE		SDL_SCANCODE_APOSTROPHE
#define KEYCODE_GRAVE			SDL_SCANCODE_GRAVE

#define KEYCODE_COMMA			SDL_SCANCODE_COMMA
#define KEYCODE_PERIOD			SDL_SCANCODE_PERIOD
#define KEYCODE_SLASH			SDL_SCANCODE_SLASH

#define KEYCODE_CAPSLOCK		SDL_SCANCODE_CAPSLOCK

#define KEYCODE_F1				SDL_SCANCODE_F1
#define KEYCODE_F2				SDL_SCANCODE_F2
#define KEYCODE_F3				SDL_SCANCODE_F3
#define KEYCODE_F4				SDL_SCANCODE_F4
#define KEYCODE_F5				SDL_SCANCODE_F5
#define KEYCODE_F6				SDL_SCANCODE_F6
#define KEYCODE_F7				SDL_SCANCODE_F7
#define KEYCODE_F8				SDL_SCANCODE_F8
#define KEYCODE_F9				SDL_SCANCODE_F9
#define KEYCODE_F10				SDL_SCANCODE_F10
#define KEYCODE_F11				SDL_SCANCODE_F11
#define KEYCODE_F12				SDL_SCANCODE_F12

#define KEYCODE_PRINTSCREEN		SDL_SCANCODE_PRINTSCREEN
#define KEYCODE_SCROLLLOCK		SDL_SCANCODE_SCROLLLOCK
#define KEYCODE_PAUSE			SDL_SCANCODE_PAUSE
#define KEYCODE_INSERT			SDL_SCANCODE_INSERT

#define KEYCODE_HOME			SDL_SCANCODE_HOME
#define KEYCODE_PAGEUP			SDL_SCANCODE_PAGEUP
#define KEYCODE_DELETE			SDL_SCANCODE_DELETE
#define KEYCODE_END				SDL_SCANCODE_END
#define KEYCODE_PAGEDOWN		SDL_SCANCODE_PAGEDOWN
#define KEYCODE_RIGHT			SDL_SCANCODE_RIGHT
#define KEYCODE_LEFT			SDL_SCANCODE_LEFT
#define KEYCODE_DOWN			SDL_SCANCODE_DOWN
#define KEYCODE_UP				SDL_SCANCODE_UP

#define KEYCODE_NUMLOCKCLEAR	SDL_SCANCODE_NUMLOCKCLEAR

#define KEYCODE_KP_DIVIDE		SDL_SCANCODE_KP_DIVIDE
#define KEYCODE_KP_MULTIPLY		SDL_SCANCODE_KP_MULTIPLY
#define KEYCODE_KP_MINUS		SDL_SCANCODE_KP_MINUS
#define KEYCODE_KP_PLUS			SDL_SCANCODE_KP_PLUS
#define KEYCODE_KP_ENTER		SDL_SCANCODE_KP_ENTER
#define KEYCODE_KP_1			SDL_SCANCODE_KP_1
#define KEYCODE_KP_2			SDL_SCANCODE_KP_2
#define KEYCODE_KP_3			SDL_SCANCODE_KP_3
#define KEYCODE_KP_4			SDL_SCANCODE_KP_4
#define KEYCODE_KP_5			SDL_SCANCODE_KP_5
#define KEYCODE_KP_6			SDL_SCANCODE_KP_6
#define KEYCODE_KP_7			SDL_SCANCODE_KP_7
#define KEYCODE_KP_8			SDL_SCANCODE_KP_8
#define KEYCODE_KP_9			SDL_SCANCODE_KP_9
#define KEYCODE_KP_0			SDL_SCANCODE_KP_0
#define KEYCODE_KP_PERIOD		SDL_SCANCODE_KP_PERIOD

#define KEYCODE_NONUSBACKSLASH	SDL_SCANCODE_NONUSBACKSLASH

#define KEYCODE_APPLICATION		SDL_SCANCODE_APPLICATION
#define KEYCODE_POWER			SDL_SCANCODE_POWER

#define KEYCODE_KP_EQUALS		SDL_SCANCODE_KP_EQUALS
#define KEYCODE_F13				SDL_SCANCODE_F13
#define KEYCODE_F14				SDL_SCANCODE_F14
#define KEYCODE_F15				SDL_SCANCODE_F15
#define KEYCODE_F16				SDL_SCANCODE_F16
#define KEYCODE_F17				SDL_SCANCODE_F17
#define KEYCODE_F18				SDL_SCANCODE_F18
#define KEYCODE_F19				SDL_SCANCODE_F19
#define KEYCODE_F20				SDL_SCANCODE_F20
#define KEYCODE_F21				SDL_SCANCODE_F21
#define KEYCODE_F22				SDL_SCANCODE_F22
#define KEYCODE_F23				SDL_SCANCODE_F23
#define KEYCODE_F24				SDL_SCANCODE_F24
#define KEYCODE_EXECUTE			SDL_SCANCODE_EXECUTE
#define KEYCODE_HELP			SDL_SCANCODE_HELP
#define KEYCODE_MENU			SDL_SCANCODE_MENU
#define KEYCODE_SELECT			SDL_SCANCODE_SELECT
#define KEYCODE_STOP			SDL_SCANCODE_STOP
#define KEYCODE_AGAIN			SDL_SCANCODE_AGAIN
#define KEYCODE_UNDO			SDL_SCANCODE_UNDO
#define KEYCODE_CUT				SDL_SCANCODE_CUT
#define KEYCODE_COPY			SDL_SCANCODE_COPY
#define KEYCODE_PASTE			SDL_SCANCODE_PASTE
#define KEYCODE_FIND			SDL_SCANCODE_FIND
#define KEYCODE_MUTE			SDL_SCANCODE_MUTE
#define KEYCODE_VOLUMEUP		SDL_SCANCODE_VOLUMEUP
#define KEYCODE_VOLUMEDOWN		SDL_SCANCODE_VOLUMEDOWN

/* not sure whether there's a reason to enable these */
/*#define KEYCODE_LOCKINGCAPSLOCK	SDL_SCANCODE_LOCKINGCAPSLOCK */
/*#define KEYCODE_LOCKINGNUMLOCK	SDL_SCANCODE_LOCKINGNUMLOCK */
/*#define KEYCODE_LOCKINGSCROLLLOCK	SDL_SCANCODE_LOCKINGSCROLLLOCK */
#define KEYCODE_KP_COMMA		SDL_SCANCODE_KP_COMMA
#define KEYCODE_KP_EQUALSAS400	SDL_SCANCODE_KP_EQUALSAS400

#define KEYCODE_INTERNATIONAL1	SDL_SCANCODE_INTERNATIONAL1
#define KEYCODE_INTERNATIONAL2	SDL_SCANCODE_INTERNATIONAL2
#define KEYCODE_INTERNATIONAL3	SDL_SCANCODE_INTERNATIONAL3
#define KEYCODE_INTERNATIONAL4	SDL_SCANCODE_INTERNATIONAL4
#define KEYCODE_INTERNATIONAL5	SDL_SCANCODE_INTERNATIONAL5
#define KEYCODE_INTERNATIONAL6	SDL_SCANCODE_INTERNATIONAL6
#define KEYCODE_INTERNATIONAL7	SDL_SCANCODE_INTERNATIONAL7
#define KEYCODE_INTERNATIONAL8	SDL_SCANCODE_INTERNATIONAL8
#define KEYCODE_INTERNATIONAL9	SDL_SCANCODE_INTERNATIONAL9

#define KEYCODE_LANG1			SDL_SCANCODE_LANG1
#define KEYCODE_LANG2			SDL_SCANCODE_LANG2
#define KEYCODE_LANG3			SDL_SCANCODE_LANG3
#define KEYCODE_LANG4			SDL_SCANCODE_LANG4
#define KEYCODE_LANG5			SDL_SCANCODE_LANG5
#define KEYCODE_LANG6			SDL_SCANCODE_LANG6
#define KEYCODE_LANG7			SDL_SCANCODE_LANG7
#define KEYCODE_LANG8			SDL_SCANCODE_LANG8
#define KEYCODE_LANG9			SDL_SCANCODE_LANG9

#define KEYCODE_ALTERASE		SDL_SCANCODE_ALTERASE
#define KEYCODE_SYSREQ			SDL_SCANCODE_SYSREQ
#define KEYCODE_CANCEL			SDL_SCANCODE_CANCEL
#define KEYCODE_CLEAR			SDL_SCANCODE_CLEAR
#define KEYCODE_PRIOR			SDL_SCANCODE_PRIOR
#define KEYCODE_RETURN2			SDL_SCANCODE_RETURN2
#define KEYCODE_SEPARATOR		SDL_SCANCODE_SEPARATOR
#define KEYCODE_OUT				SDL_SCANCODE_OUT
#define KEYCODE_OPER			SDL_SCANCODE_OPER
#define KEYCODE_CLEARAGAIN		SDL_SCANCODE_CLEARAGAIN
#define KEYCODE_CRSEL			SDL_SCANCODE_CRSEL
#define KEYCODE_EXSEL			SDL_SCANCODE_EXSEL

#define KEYCODE_KP_00			SDL_SCANCODE_KP_00
#define KEYCODE_KP_000			SDL_SCANCODE_KP_000
#define KEYCODE_THOUSANDSSEPARATOR	SDL_SCANCODE_THOUSANDSSEPARATOR
#define KEYCODE_DECIMALSEPARATOR	SDL_SCANCODE_DECIMALSEPARATOR
#define KEYCODE_CURRENCYUNIT	SDL_SCANCODE_CURRENCYUNIT
#define KEYCODE_CURRENCYSUBUNIT	SDL_SCANCODE_CURRENCYSUBUNIT
#define KEYCODE_KP_LEFTPAREN	SDL_SCANCODE_KP_LEFTPAREN
#define KEYCODE_KP_RIGHTPAREN	SDL_SCANCODE_KP_RIGHTPAREN
#define KEYCODE_KP_LEFTBRACE	SDL_SCANCODE_KP_LEFTBRACE
#define KEYCODE_KP_RIGHTBRACE	SDL_SCANCODE_KP_RIGHTBRACE
#define KEYCODE_KP_TAB			SDL_SCANCODE_KP_TAB
#define KEYCODE_KP_BACKSPACE	SDL_SCANCODE_KP_BACKSPACE
#define KEYCODE_KP_A			SDL_SCANCODE_KP_A
#define KEYCODE_KP_B			SDL_SCANCODE_KP_B
#define KEYCODE_KP_C			SDL_SCANCODE_KP_C
#define KEYCODE_KP_D			SDL_SCANCODE_KP_D
#define KEYCODE_KP_E			SDL_SCANCODE_KP_E
#define KEYCODE_KP_F			SDL_SCANCODE_KP_F
#define KEYCODE_KP_XOR			SDL_SCANCODE_KP_XOR
#define KEYCODE_KP_POWER		SDL_SCANCODE_KP_POWER
#define KEYCODE_KP_PERCENT		SDL_SCANCODE_KP_PERCENT
#define KEYCODE_KP_LESS			SDL_SCANCODE_KP_LESS
#define KEYCODE_KP_GREATER		SDL_SCANCODE_KP_GREATER
#define KEYCODE_KP_AMPERSAND	SDL_SCANCODE_KP_AMPERSAND
#define KEYCODE_KP_DBLAMPERSAND	SDL_SCANCODE_KP_DBLAMPERSAND
#define KEYCODE_KP_VERTICALBAR	SDL_SCANCODE_KP_VERTICALBAR
#define KEYCODE_KP_DBLVERTICALBAR	SDL_SCANCODE_KP_DBLVERTICALBAR
#define KEYCODE_KP_COLON		SDL_SCANCODE_KP_COLON
#define KEYCODE_KP_HASH			SDL_SCANCODE_KP_HASH
#define KEYCODE_KP_SPACE		SDL_SCANCODE_KP_SPACE
#define KEYCODE_KP_AT			SDL_SCANCODE_KP_AT
#define KEYCODE_KP_EXCLAM		SDL_SCANCODE_KP_EXCLAM
#define KEYCODE_KP_MEMSTORE		SDL_SCANCODE_KP_MEMSTORE
#define KEYCODE_KP_MEMRECALL	SDL_SCANCODE_KP_MEMRECALL
#define KEYCODE_KP_MEMCLEAR		SDL_SCANCODE_KP_MEMCLEAR
#define KEYCODE_KP_MEMADD		SDL_SCANCODE_KP_MEMADD
#define KEYCODE_KP_MEMSUBTRACT	SDL_SCANCODE_KP_MEMSUBTRACT
#define KEYCODE_KP_MEMMULTIPLY	SDL_SCANCODE_KP_MEMMULTIPLY
#define KEYCODE_KP_MEMDIVIDE	SDL_SCANCODE_KP_MEMDIVIDE
#define KEYCODE_KP_PLUSMINUS	SDL_SCANCODE_KP_PLUSMINUS
#define KEYCODE_KP_CLEAR		SDL_SCANCODE_KP_CLEAR
#define KEYCODE_KP_CLEARENTRY	SDL_SCANCODE_KP_CLEARENTRY
#define KEYCODE_KP_BINARY		SDL_SCANCODE_KP_BINARY
#define KEYCODE_KP_OCTAL		SDL_SCANCODE_KP_OCTAL
#define KEYCODE_KP_DECIMAL		SDL_SCANCODE_KP_DECIMAL
#define KEYCODE_KP_HEXADECIMAL	SDL_SCANCODE_KP_HEXADECIMAL

#define KEYCODE_LCTRL			SDL_SCANCODE_LCTRL
#define KEYCODE_LSHIFT			SDL_SCANCODE_LSHIFT
#define KEYCODE_LALT			SDL_SCANCODE_LALT
#define KEYCODE_LGUI			SDL_SCANCODE_LGUI
#define KEYCODE_RCTRL			SDL_SCANCODE_RCTRL
#define KEYCODE_RSHIFT			SDL_SCANCODE_RSHIFT
#define KEYCODE_RALT			SDL_SCANCODE_RALT
#define KEYCODE_RGUI			SDL_SCANCODE_RGUI

#define KEYCODE_MODE			SDL_SCANCODE_MODE

#define KEYCODE_AUDIONEXT		SDL_SCANCODE_AUDIONEXT
#define KEYCODE_AUDIOPREV		SDL_SCANCODE_AUDIOPREV
#define KEYCODE_AUDIOSTOP		SDL_SCANCODE_AUDIOSTOP
#define KEYCODE_AUDIOPLAY		SDL_SCANCODE_AUDIOPLAY
#define KEYCODE_AUDIOMUTE		SDL_SCANCODE_AUDIOMUTE
#define KEYCODE_MEDIASELECT		SDL_SCANCODE_MEDIASELECT
#define KEYCODE_WWW				SDL_SCANCODE_WWW
#define KEYCODE_MAIL			SDL_SCANCODE_MAIL
#define KEYCODE_CALCULATOR		SDL_SCANCODE_CALCULATOR
#define KEYCODE_COMPUTER		SDL_SCANCODE_COMPUTER
#define KEYCODE_AC_SEARCH		SDL_SCANCODE_AC_SEARCH
#define KEYCODE_AC_HOME			SDL_SCANCODE_AC_HOME
#define KEYCODE_AC_BACK			SDL_SCANCODE_AC_BACK
#define KEYCODE_AC_FORWARD		SDL_SCANCODE_AC_FORWARD
#define KEYCODE_AC_STOP			SDL_SCANCODE_AC_STOP
#define KEYCODE_AC_REFRESH		SDL_SCANCODE_AC_REFRESH
#define KEYCODE_AC_BOOKMARKS	SDL_SCANCODE_AC_BOOKMARKS

#define KEYCODE_BRIGHTNESSDOWN	SDL_SCANCODE_BRIGHTNESSDOWN
#define KEYCODE_BRIGHTNESSUP	SDL_SCANCODE_BRIGHTNESSUP
#define KEYCODE_DISPLAYSWITCH	SDL_SCANCODE_DISPLAYSWITCH

#define KEYCODE_KBDILLUMTOGGLE	SDL_SCANCODE_KBDILLUMTOGGLE
#define KEYCODE_KBDILLUMDOWN	SDL_SCANCODE_KBDILLUMDOWN
#define KEYCODE_KBDILLUMUP		SDL_SCANCODE_KBDILLUMUP
#define KEYCODE_EJECT			SDL_SCANCODE_EJECT
#define KEYCODE_SLEEP			SDL_SCANCODE_SLEEP

#define KEYCODE_APP1			SDL_SCANCODE_APP1
#define KEYCODE_APP2			SDL_SCANCODE_APP2

/* Convert to JP keyboard */
#define KEYCODE_CARET			KEYCODE_EQUALS
#define KEYCODE_COLON			KEYCODE_APOSTROPHE

/* henkan */
#define KEYCODE_HENKAN			SDL_SCANCODE_INTERNATIONAL4
/* muhenkan */
#define KEYCODE_MUHENKAN		SDL_SCANCODE_INTERNATIONAL5
/* katakana / hiragana */
#define KEYCODE_KATAHIRA		SDL_SCANCODE_INTERNATIONAL2
/* eisu(mac) */
#define KEYCODE_EISU			SDL_SCANCODE_INTERNATIONAL7
/* kana(mac) */
#define KEYCODE_KANA			SDL_SCANCODE_INTERNATIONAL8
/* fn */
#define KEYCODE_FUNCTION        SDL_SCANCODE_INTERNATIONAL9

#define KEYCODE_AT				SDL_SCANCODE_LEFTBRACKET
#undef  KEYCODE_LEFTBRACKET
#define KEYCODE_LEFTBRACKET		SDL_SCANCODE_RIGHTBRACKET
#undef  KEYCODE_RIGHTBRACKET
#define KEYCODE_RIGHTBRACKET	SDL_SCANCODE_BACKSLASH
#undef  KEYCODE_BACKSLASH
#define KEYCODE_BACKSLASH		SDL_SCANCODE_INTERNATIONAL3
#define KEYCODE_UNDERSCORE		SDL_SCANCODE_INTERNATIONAL1
#undef  KEYCODE_MENU
#define KEYCODE_MENU			SDL_SCANCODE_APPLICATION

#endif /* USE_SDL2 */


#define GLOBALKEY_RETURN		0x0d
#define GLOBALKEY_CONTROL		0x11
#define GLOBALKEY_0				0x30
#define GLOBALKEY_1				0x31
#define GLOBALKEY_2				0x32
#define GLOBALKEY_3				0x33
#define GLOBALKEY_4				0x34
#define GLOBALKEY_5				0x35
#define GLOBALKEY_6				0x36
#define GLOBALKEY_7				0x37
#define GLOBALKEY_8				0x38
#define GLOBALKEY_9				0x39
#define GLOBALKEY_A				0x41
#define GLOBALKEY_B				0x42
#define GLOBALKEY_C				0x43
#define GLOBALKEY_D				0x44
#define GLOBALKEY_E				0x45
#define GLOBALKEY_F				0x46
#define GLOBALKEY_G				0x47
#define GLOBALKEY_H				0x48
#define GLOBALKEY_I				0x49
#define GLOBALKEY_J				0x4a
#define GLOBALKEY_K				0x4b
#define GLOBALKEY_L				0x4c
#define GLOBALKEY_M				0x4d
#define GLOBALKEY_N				0x4e
#define GLOBALKEY_O				0x4f
#define GLOBALKEY_P				0x50
#define GLOBALKEY_Q				0x51
#define GLOBALKEY_R				0x52
#define GLOBALKEY_S				0x53
#define GLOBALKEY_T				0x54
#define GLOBALKEY_U				0x55
#define GLOBALKEY_V				0x56
#define GLOBALKEY_W				0x57
#define GLOBALKEY_X				0x58
#define GLOBALKEY_Y				0x59
#define GLOBALKEY_Z				0x5a
#define GLOBALKEY_F1			0x11a
#define GLOBALKEY_F2			0x11b
#define GLOBALKEY_F3			0x11c
#define GLOBALKEY_F4			0x11d
#define GLOBALKEY_F5			0x11e
#define GLOBALKEY_F6			0x11f
#define GLOBALKEY_F7			0x120
#define GLOBALKEY_F8			0x121
#define GLOBALKEY_F9			0x122
#define GLOBALKEY_F10			0x123
#define GLOBALKEY_F11			0x124
#define GLOBALKEY_F12			0x125
#define GLOBALKEY_F13			0x126
#define GLOBALKEY_F14			0x127
#define GLOBALKEY_F15			0x128


#endif	/* _KEYCODE_H_ */
